{ 4I27 DEMO SOFTWARE - TEST PROGRAM FOR 4I27 }

{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }
{$N-}    {No numeric coprocessor}
uses crt;
{$I ..\4I27\4I27LOW }                 { include low level 4I27 I/O }
{ program simple motion test for 4I27 }
const I27Card = $200;                          { default 4I27 location }

var

Motor0 : motor;
Motor1 : motor;
MoveStatus : byte;

procedure InitFilterParameters(motorx : motor);
begin
  with motorx.Filter do
  begin
    KP := 375;                                   { relativly hi gain }
    KI := 10;                                    { integrated error }
    KD := 2200;                                  { some value for damping }
    IL := 5;                                     { low integration limit for now }
  end; {with}
  LoadFilterParameters(motorx);
  UpdateFilter(motorx);
end;

procedure shutdown;
begin
  StopSmoothly(Motor0);
  StopSmoothly(Motor1);
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  Halt(0);
end;

procedure MoveOK(status : byte);
begin
  if status and ExcessivePosMask <> 0 then
  begin
    writeln('Moves stopped do to excessive position error');
    ShutDown;
  end;
end;


begin                                          {main}
  DirectVideo := false;
  writeln('About to reset the 4I27A');
  if not Reset4I27A(I27Card) then
  begin
    writeln('Couldn''t reset 4I27A card... aborting');
    halt(2);
  end;
  writeln('LM628''S sucessfully reset... proceeding with set-up');
  AssignMotor(Motor0,I27Card,0);               { assign motor 0 to first half of first card }
  AssignMotor(Motor1,I27Card,1);               { assign motor 1 to second half of second card }
  SetMotionMode(Motor0,PositionMode);          { set up motor 0 for position mode }
  SetMotionMode(Motor1,PositionMode);          { set up motor 1 for position mode }
  SetSamplingInterval(Motor0,0);               { set motor 0 for minimum sampling interval }
  SetSamplingInterval(Motor1,0);               { set motor 1 for minimum sampling interval }
  InitFilterParameters(Motor0);
  InitFilterParameters(Motor1);
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  LoadPosErrForStop(Motor0,25000);
  LoadPosErrForStop(Motor1,25000);
  DefineHome(Motor0);
  DefineHome(Motor1);
  MoveStatus := 0;
  writeln('About to start moves');
  while not keypressed do
  begin
    MoveOK(PolledXYMove(Motor0,Motor1,1320,1320,90000,5000));
    MoveOK(PolledXYMove(Motor0,Motor1,-1320,-1320,40000,1000));
    MoveOK(PolledXYMove(Motor0,Motor1,1320*10,1320*10,60000,500));
    MoveOK(PolledXYMove(Motor0,Motor1,0,0,90000,100));
  end;
  shutdown;
  end.{while}
